<script setup lang="ts">

import ActionButton from "@/components/atoms/button/ActionButton.vue";
import ExternalLink from "@/components/atoms/link/ExternalLink.vue";
import BaseButton from "@/components/atoms/button/BaseButton.vue";
import DangerButton from "@/components/atoms/button/DangerButton.vue";
import Repository from "@/entities/Repository/Repository";
import EntityPresentationSection from "@/components/organisms/section/entity/EntityPresentationSection.vue";
import LabeledComponent from "@/components/molecules/text/LabeledComponent.vue";
import {useRepositoryNewVersionModalStore} from "@/stores/Repository/RepositoryNewVersionModalStore";
import NewVersionModal from "@/components/organisms/modal/Repository/NewVersionModal/NewVersionModal.vue";

const newVersionModalStore = useRepositoryNewVersionModalStore();

defineProps<{ repository: Repository }>();
</script>

<template>
  <EntityPresentationSection :img="repository.img" :alt="repository.name">
    <template #default>
      <LabeledComponent label="Nom :">
        <ExternalLink :href="repository.link">{{ repository.name }}</ExternalLink>
      </LabeledComponent>
      <LabeledComponent label="Dernière version :">
        <span>{{ repository.latestVersionFormattedCode }}</span>
      </LabeledComponent>
      <LabeledComponent label="NB. instances :">
        <span>{{ Math.round(Math.random() * 10) }}</span>
      </LabeledComponent>
      <LabeledComponent label="NB. sous modules :">
        <span>{{ repository.subModules.length }}</span>
      </LabeledComponent>
      <LabeledComponent label="NB. dépôts parents :">
        <span>{{ repository.parentRepositories.length }}</span>
      </LabeledComponent>
      <RouterLink to="/merge-requests">
        <LabeledComponent label="NB. MR/PR à traiter :">
          <span>{{ Math.round(Math.random() * 10) }}</span>
        </LabeledComponent>
      </RouterLink>
      <LabeledComponent label="Branche dev. :">
        {{ repository.devBranch ? repository.devBranch : 'Aucune' }}
      </LabeledComponent>
      <LabeledComponent label="Branche prod. :">
        {{ repository.mainBranch }}
      </LabeledComponent>
    </template>
    <template #actions>
      <NewVersionModal/>
      <BaseButton :withBorder="true" @click="() => newVersionModalStore.show(repository)">Nouvelle version</BaseButton>
      <ActionButton>Modifier</ActionButton>
      <DangerButton>Supprimer</DangerButton>
    </template>
  </EntityPresentationSection>
</template>